
/*
  A wrapper for some common sorting/searching/filtering methods etc, mostly using java.util.Collections
 */

public static class TransactionUtils
{
  public static final int ASCENDING = 1;
  public static final int DESCENDING = -1;
  
 
  //pass in a List of Transactions and it returns a List of Map.Entrys mapping the unique subject name --> num times found in Transactions

  public static String getStringKeyForEntry(Object o)
  {
    Map.Entry me = (Map.Entry) o;
    return (String) me.getKey();
  }

  public static int getIntValueForEntry(Object o)
  {
    Map.Entry me = (Map.Entry) o;
    return ((Integer) me.getValue()).intValue();
  }
  
  //sort a list of Map.Entrys by their value. This assumes that the value is an Integer! 
  //order = 1 for Ascending, order = -1 for descending.  
  public static void sortUniqueEntriesByCount(ArrayList entryList, final int order)
  {
    Collections.sort(entryList, new Comparator()
    {
      public int compare(Object o1, Object o2)
      {
        Map.Entry me1 = (Map.Entry) o1;
        Map.Entry me2 = (Map.Entry) o2;

        return (((Integer)me1.getValue()).intValue() - ((Integer)me2.getValue()).intValue()) * order;
      }
    }
    );
  }

  //reverse order of List
  public static void reverse(ArrayList transactions)
  {
    Collections.reverse(transactions); 
  }
  
  public static String getOrdinal(int value)
  {
    switch (value)
    {
      case 1:
        return "st";
      case 2:
        return "nd";
      case 3:
        return "rd";
      default:
        return "th";
    }
  }

}

